题目描述
给定一个排序数组和一个目标值,在数组中找到目标值,并返回其索引。如果目标值不存在于数组中,返回它将会被按顺序插入的位置。
请必须使用时间复杂度为 O(log n) 的算法。
题解1
int searchInsert(int* nums, int numsSize, int target) {
for (int i = 0; i < numsSize; i++) {
if (nums[i] >= target) {
return i;
}
}
return numsSize; // If target is greater than all elements, insert at the end
}
题解2:二分查找
思路与算法
假设题意是叫你在排序数组中寻找是否存在一个目标值,那么训练有素的读者肯定立马就能想到利用二分法在 O(log n)
的时间内找到是否存在目标值。但这题还多了个额外的条件,即如果不存在数组中的时候需要返回按顺序插入的位置,那我们还能用二分法么?答案是可以的,我们只需要稍作修改即可。
考虑这个插入的位置 pos
,它成立的条件为:
nums[pos−1]<target≤nums[pos]
其中 nums
代表排序数组。由于如果存在这个目标值,我们返回的索引也是 pos
,因此我们可以将两个条件合并得出最后的目标:「在一个有序数组中找第一个大于等于 target
的下标」。
问题转化到这里,直接套用二分法即可,即不断用二分法逼近查找第一个大于等于 target
的下标 。下文给出的代码是笔者习惯的二分写法,ans
初值设置为数组长度可以省略边界条件的判断,因为存在一种情况是 target
大于数组中的所有数,此时需要插入到数组长度的位置。
代码
int searchInsert(int* nums, int numsSize, int target) {
// Initialize left and right pointers and set the default answer to numsSize
int left = 0, right = numsSize - 1, ans = numsSize;
// Perform binary search
while (left <= right) {
// Calculate the middle index
int mid = ((right - left) >> 1) + left;
// If the target is less than or equal to the value at mid
if (target <= nums[mid]) {
// Update the answer to the current mid index
ans = mid;
// Update the right pointer to search in the left half
right = mid - 1;
} else {
// Update the left pointer to search in the right half
left = mid + 1;
}
}
// Return the final answer
return ans;
}
复杂度分析
时间复杂度:O(logn)
,其中 n
为数组的长度。二分查找所需的时间复杂度为 O(logn)
。
空间复杂度:O(1)
。我们只需要常数空间存放若干变量。
作者:力扣官方题解
链接:https://leetcode.cn/problems/search-insert-position/solutions/333632/sou-suo-cha-ru-wei-zhi-by-leetcode-solution/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。